#!/bin/sh

set -e

cd $(dirname $0)

. ../../../common/config.sh
. ../../../common/log.sh

log_start "$0" "grpck report failures when it cannot open the local gshadow file"

save_config

# restore the files on exit
trap 'log_status "$0" "FAILURE"; restore_config' 0

change_config

echo -n "Check local groups (grpck data/group data/gshadow)..."
LD_PRELOAD=../../../common/open_RDWR_failure.so FAILURE_PATH=data/gshadow grpck data/group data/gshadow 2>tmp/grpck.err && exit 1 || {
	status=$?
}
echo "OK"

echo -n "Check returned status ($status)..."
test "$status" = "3"
echo "OK"

echo "grpck reported:"
echo "======================================================================="
cat tmp/grpck.err
echo "======================================================================="
echo -n "Check that there were a failure message..."
diff -au data/grpck.err tmp/grpck.err
echo "error message OK."
rm -f tmp/grpck.err

echo -n "Check the passwd file..."
../../../common/compare_file.pl config/etc/passwd /etc/passwd
echo "OK"
echo -n "Check the group file..."
../../../common/compare_file.pl config/etc/group /etc/group
echo "OK"
echo -n "Check the shadow file..."
../../../common/compare_file.pl config/etc/shadow /etc/shadow
echo "OK"
echo -n "Check the gshadow file..."
../../../common/compare_file.pl config/etc/gshadow /etc/gshadow
echo "OK"

log_status "$0" "SUCCESS"
restore_config
trap '' 0

